#include <stdio.h>
#include <math.h>

#include "uusbd.h"
#include "urcc.h"
#include <process.h>    /* _beginthread, _endthread */

#define NUM_INTERFACE	0  // dumpC^[tF[X̔ԍ
#define NUM_PIPE		0  // dumppCv̔ԍ
#define LOOPCOUNT		10 // JԂ

#define maxControllers 30
//#define DEBUG				// ʕ\tO

USHORT get_max_packet(HUSB husb, DWORD if_num, DWORD pipe_num){
	char *buf,*p;
	USHORT max_len;
	DWORD pipe_count, len;
	BOOL ok;
	USB_CONFIGURATION_DESCRIPTOR conf;
	PUSB_ENDPOINT_DESCRIPTOR endp_descriptor;
	//܂RtBO[VfBXNv^[̂ݓđŜ̑傫m
	ok = Uusbd_GetConfigurationDescriptor(husb,(char*)&conf, sizeof(conf));
	if(!ok) return 0;
	len = conf.wTotalLength;
	buf = (char*)malloc(len);
	//Ŝ𓾂
	ok = Uusbd_GetConfigurationDescriptor(husb,buf, len);
	if(!ok) return 0;

	p = buf; max_len = 0; pipe_count = 0; ok = FALSE;
	while(len>0) {
		if(p[1] == USB_INTERFACE_DESCRIPTOR_TYPE){ // interface descriptor
			if((unsigned) p[2] == if_num) ok = TRUE;
			else ok = FALSE;
			pipe_count = 0;
		}
		if(p[1] == USB_ENDPOINT_DESCRIPTOR_TYPE && ok){ // endpoint descriptor
			if(pipe_count == pipe_num) { // found !!
				endp_descriptor = (PUSB_ENDPOINT_DESCRIPTOR)p;
				max_len = endp_descriptor->wMaxPacketSize;
				break;
			}
			pipe_count++; // fix Ver1.1
		}
		p += p[0];
		len -= p[0];
	}
	free(buf);
	return max_len;
}


void main(void){
	HUSB husb[maxControllers];
	HANDLE hContinous[maxControllers], hCounter[maxControllers], hDesire[maxControllers];
	unsigned char *buf, numDev;
	unsigned short *tBuf;
	DWORD size, ret, i, maxlen[maxControllers];
	// p
	struct urcout cmd[maxControllers];
	unsigned short a, b, j;

	// ϐ̏
	numDev = 0;
	j = 0;

	// USBfoCX̃I[v
	for(;;){
		husb[numDev] = Uusbd_Open();
		if(husb[numDev] == INVALID_HANDLE_VALUE){
			break;
		}else{
			printf("USBnh:%d\n",husb[numDev]);
			numDev++;
		}
	}
	if(numDev == 0) {
		printf("Uusbd.sysgUSBfoCX͌܂\n");
		return;
	}
	
	// USBfoCX̊mF
	for(i=0;i<numDev;i++){
		ret = Uusbd_Check(husb[i]);
		switch(ret){
			case UU_CHECK_OK:
				printf("USBnh:%d ͐ɓ삵Ă܂.\n",husb[i]);
				break;
			case UU_CHECK_NOTOPEN:
				printf("USBnh:%d ͖ł.\n",husb[i]);
				break;
			case UU_CHECK_NODEVICE:
				printf("USBnh:%d ͎OĂ܂.\n",husb[i]);
				break;
		}
	}

	// Ŝ̑傫m
	for(i=0;i<numDev;i++){
		maxlen[i] = get_max_packet(husb[i], 0, 0);
		if(maxlen[i] == 0) {
			printf("Can't Get max packet length\n");
			return;
		}
		printf("max packet size =%d\n",maxlen[i]);
	}

	// obt@̊m
	buf = (char*)malloc(maxlen[0]);
	tBuf = (short*)malloc(maxlen[0]);
	
	tBuf = (unsigned short *)buf;

	// pCṽI[v
	for(i=0;i<numDev;i++){
		hContinous[i] = Uusbd_OpenPipe(husb[i], 0, 2);
		if(hContinous == INVALID_HANDLE_VALUE){
			printf("f[^ǂݍݗp̃pCvI[vɎs.\n");
		}
		hDesire[i] = Uusbd_OpenPipe(husb[i], 0, 1);
		if(hDesire == INVALID_HANDLE_VALUE){
			printf("f[^ݗp̃pCvI[vɎs.\n");
		}
		hCounter[i] = Uusbd_OpenPipe(husb[i], 0, 3);
		if(hCounter == INVALID_HANDLE_VALUE){
			printf("f[^ݗp̃pCvI[vɎs.\n");
		}
	}

	// USBfoCX̃Zbg
	for(i=0;i<numDev;i++){
		Uusbd_ResetDevice(husb[i]);
	}

	for(;;){
		for(i=0;i<numDev;i++){
			j+=5;

			a = (unsigned short)(2500.0 + 700.0 * (sin(j*3.14/500.0)));

			if(j>1000)	j=0;
			cmd[i].duty[0] = cmd[i].duty[1] = cmd[i].duty[2] = cmd[i].duty[3] = a;

			printf("PWMl=%4d\t",a);

			// f[^̏
			if(WriteFile(hDesire[i], &cmd[i], sizeof(cmd[i]), &size, NULL)<0){
				printf("f[^݃G[.\n");
				break;
			}
			Uusbd_ResetPipe(hDesire[i]);

			ret = ReadFile(hContinous[i], buf, maxlen[0], &size, NULL);
			if(ret ==0 || size == 0) {
				printf("read error ret=%d size=%d\n",ret,size);
				ret = Uusbd_Check(husb[i]);
				if(ret != UU_CHECK_OK) {
					printf("foCXO܂\n");
					break;
				}
				// pCṽZbg
				Uusbd_ResetPipe(hContinous);
				Sleep(100);
				continue;
			}
		printf("ADRo[^̒l:%04X\t%04X\t%04X\t%04X\t\n ", tBuf[2],tBuf[3],tBuf[4],tBuf[5]);

		}
	}

	for(i=0;i<numDev;i++){
		CloseHandle(hContinous[i]);
		CloseHandle(hDesire[i]);
		CloseHandle(hCounter[i]);
		Uusbd_Close(husb[i]);
	}
	free(buf);
	free(tBuf);
}